// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/10/25
// Update  : 2009/10/25
// Description : 元サイズより縮小して表示されている画像をクリックにより拡大表示する
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
try{document.execCommand('BackgroundImageCache', false, true);}catch(e){}
@*/
var imageSizeExpand = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		targetClass : 'sizeExpand', // 対象クラス
		rolloverColor : '#fff', // ロールオーバー色
		effect : 'fade', // アニメーション種類 --> 'normal','appear', 'dropdown', 'slide', 'fade'
		overlayColor : '#000', // 画像拡大時の背景色
		moveSpeed : 8, // 移動の速さ
		expandSpeed : 6, // 拡大の速さ
		fadeSpeed : 6 // フェードの速さ
	},
	storage : {
		selectImage : null,
		overlay : null,
		roLayer : null,
		imgLayer : [],
		viewing : null,
		exec : false,
		disp : false
	},
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	init : function() {
		// layer生成
		var roLayer = imageSizeExpand.createRoLayer();
		// layerに関数付加
		imageSizeExpand.addEvent( roLayer, 'mouseout', imageSizeExpand.out );
		imageSizeExpand.addEvent( roLayer, 'click', imageSizeExpand.roClick );
		// layerを保持
		imageSizeExpand.storage.roLayer = roLayer;
		// shimを生成
		var overlay = imageSizeExpand.createShim();
		// shimに関数付加
		if ( imageSizeExpand.isIE() ) {
			imageSizeExpand.addEvent( overlay.contentWindow.document, 'click', imageSizeExpand.imgClick );
		} else {
			imageSizeExpand.addEvent( (overlay.contentWindow||overlay.contentDocument), 'click', imageSizeExpand.imgClick );
		}
		// shimを保持
		imageSizeExpand.storage.overlay = overlay;
		// 対象img要素を取得
		var imgs = imageSizeExpand.getTargetElements( 'img', imageSizeExpand.conf.targetClass );
		var len = imgs.length;
		for ( var i = 0; i < len; i++ ) {
			// img要素の元サイズ取得
			var originSize = imageSizeExpand.getOriginalImageSize(imgs[i]);
			// img要素の表示サイズ取得
			var viewSize = imageSizeExpand.getElementSize( imgs[i] );
			// 縮小されている場合
			if ( (originSize.width > viewSize.width) || (originSize.height > viewSize.height) ) {
				// img要素に関数付加
				imageSizeExpand.addEvent( imgs[i], 'mouseover', imageSizeExpand.over );
				// layer生成
				var imgLayer = imageSizeExpand.createLayer(imgs[i]);
				// 関数付加
				imageSizeExpand.addEvent( imgLayer, 'click', imageSizeExpand.imgClick );
				// 保持
				imageSizeExpand.storage.imgLayer[imageSizeExpand.storage.imgLayer.length] = [ imgs[i], imgLayer ];
			}
		}
	},
	//-----------------------------------------
	// マウスオン
	//-----------------------------------------
	over : function() {
		// 対象img要素を保持
		imageSizeExpand.storage.selectImage = this;
		// layerに位置をセット
		var pos = imageSizeExpand.getElementPosition( this );
		imageSizeExpand.setPosition( imageSizeExpand.storage.roLayer, pos.top-1, pos.left-1 );
		// layerにサイズをセット
		var size = imageSizeExpand.getElementSize( this );
		imageSizeExpand.setSize( imageSizeExpand.storage.roLayer, size.width+2, size.height+2 );
		// 色をセット
		imageSizeExpand.storage.roLayer.style.backgroundColor = imageSizeExpand.conf.rolloverColor;
		// 透明度セット
		imageSizeExpand.setOpacity( imageSizeExpand.storage.roLayer, 5 );
	},
	//-----------------------------------------
	// マウスアウト
	//-----------------------------------------
	out : function() {
		// layerに位置をリセット
		imageSizeExpand.setPosition( this, 0, 0 );
		// layerにサイズをリセット
		imageSizeExpand.setSize( this, 0, 0 );
		// 色をリセット
		this.style.backgroundColor = 'transparent';
		// 透明度リセット
		imageSizeExpand.setOpacity( this, 0 );
	},
	//-----------------------------------------
	// ロールオーバー用layerクリック
	//-----------------------------------------
	roClick : function() {
		if ( !imageSizeExpand.storage.exec && !imageSizeExpand.storage.disp ) {
			// 実行中フラグセット
			imageSizeExpand.storage.exec = true;
			var len = imageSizeExpand.storage.imgLayer.length;
			for ( var i = 0; i < len; i++ ) {
				if ( imageSizeExpand.storage.imgLayer[i][0] === imageSizeExpand.storage.selectImage ) {
					// shimの設定
					var pgSize = imageSizeExpand.getPageSize();
					var shim = imageSizeExpand.storage.overlay;
					imageSizeExpand.setPosition( shim, 0, 0 );
					imageSizeExpand.setSize( shim, pgSize.width, pgSize.height );
					if ( imageSizeExpand.isIE() ) {
						shim.contentWindow.document.body.style.backgroundColor = imageSizeExpand.conf.overlayColor;
					} else {
						shim.style.backgroundColor = imageSizeExpand.conf.overlayColor;
					}
					imageSizeExpand.setOpacity( shim, 0 );
					// 要素取得
					var layer = imageSizeExpand.storage.imgLayer[i][1];
					var image = imageSizeExpand.storage.imgLayer[i][0];
					// 情報取得
					var pos = imageSizeExpand.getElementPosition( image );
					var size = imageSizeExpand.getElementSize( image );
					var originSize = imageSizeExpand.getOriginalImageSize( image );
					// layerの設定
					imageSizeExpand.setPosition( layer, pos.top, pos.left );
					imageSizeExpand.setSize( layer, size.width, size.height );
					// layer内の画像取得
					image = layer.getElementsByTagName('IMG');
					// スクリーンサイズ取得
					var scSize = imageSizeExpand.getScreenSize();
					// リサイズ値の取得
					if ( (originSize.width > scSize.width) || (originSize.height > scSize.height) ) {
						var resize = imageSizeExpand.getResizeValue(originSize, scSize);
						originSize.width = resize.width;
						originSize.height = resize.height;
					}
					// 現在の画像サイズをセット
					image[0].width = size.width;
					image[0].height = size.height;
					// layerの現在位置を取得
					var layerPos = imageSizeExpand.getElementPosition( layer );
					// 表示中要素を保持
					imageSizeExpand.storage.viewing = [ image[0], layer, originSize, scSize, layerPos ];
					// shimのフェード開始
					shim.style.visibility = 'visible';
					imageSizeExpand.fade2shim();
				}
			}
		}
	},
	//-----------------------------------------
	// layerのフェード
	//-----------------------------------------
	fade2shim : function() {
		// 透明度設定
		var opacity = imageSizeExpand.getOpacity( imageSizeExpand.storage.overlay );
		if ( opacity < 6 ) {
			// 透過処理
			imageSizeExpand.setOpacity( imageSizeExpand.storage.overlay, (opacity + 0.7) );
			window.setTimeout('imageSizeExpand.fade2shim()', imageSizeExpand.conf.fadeSpeed);
		} else {
			window.setTimeout('imageSizeExpand.exec()', 100);
		}
	},
	exec : function() {
		// アニメーション開始
		switch ( imageSizeExpand.conf.effect ) {
			case 'normal':
				imageSizeExpand.normalAnimation();
				break;
			case 'appear':
				imageSizeExpand.appearAnimation();
				break;
			case 'dropdown':
				imageSizeExpand.dropdownAnimation();
				break;
			case 'slide':
				imageSizeExpand.slideAnimation();
				break;
			case 'fade':
				imageSizeExpand.fadeAnimation();
				break;
			default:
				imageSizeExpand.normalAnimation();
				break;
		}
	},
	//-----------------------------------------
	// 拡大画像用layerクリック
	//-----------------------------------------
	imgClick : function() {
		if ( !imageSizeExpand.storage.exec && imageSizeExpand.storage.disp ) {
			// layerリセット
			imageSizeExpand.resetLayer( imageSizeExpand.storage.viewing[1], imageSizeExpand.storage.viewing[0] );
			// shimリセット
			imageSizeExpand.resetShim( imageSizeExpand.storage.overlay );
			// 表示フラグリセット
			imageSizeExpand.storage.disp = false;
		}
	},
	//-----------------------------------------
	// 画像位置移動（normal）
	//-----------------------------------------
	normalAnimation : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var scSize = imageSizeExpand.storage.viewing[3];
		// 移動処理
		var val1 = ((scSize.width-originSize.width)/2) + (document.documentElement.scrollLeft||document.body.scrollLeft);
		var val2 = ((scSize.height-originSize.height)/2) + (document.documentElement.scrollTop||document.body.scrollTop);
		imageSizeExpand.setPosition( imageSizeExpand.storage.viewing[1], val2, val1 );
		// 拡大処理
		imageSizeExpand.setSize( imageSizeExpand.storage.viewing[0], originSize.width, originSize.height );
		imageSizeExpand.setSize( imageSizeExpand.storage.viewing[1], originSize.width, originSize.height );
		// layerと画像を表示
		imageSizeExpand.storage.viewing[1].style.visibility = 'visible';
		imageSizeExpand.storage.viewing[0].style.display = 'inline';
		// 実行中フラグリセット
		imageSizeExpand.storage.exec = false;
		// 表示フラグセット
		imageSizeExpand.storage.disp = true;
	},
	//-----------------------------------------
	// 画像位置移動（appear）
	//-----------------------------------------
	appearAnimation : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var scSize = imageSizeExpand.storage.viewing[3];
		// 移動処理
		var val1 = ((scSize.width-originSize.width)/2) + (document.documentElement.scrollLeft||document.body.scrollLeft);
		var val2 = ((scSize.height-originSize.height)/2) + (document.documentElement.scrollTop||document.body.scrollTop);
		imageSizeExpand.setPosition( imageSizeExpand.storage.viewing[1], val2, val1 );
		// layerと画像を表示
		imageSizeExpand.storage.viewing[1].style.visibility = 'visible';
		imageSizeExpand.storage.viewing[0].style.display = 'inline';
		// 画像拡大
		imageSizeExpand.expand();
	},
	//-----------------------------------------
	// 画像位置移動（move）
	//-----------------------------------------
	moveAnimation : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var scSize = imageSizeExpand.storage.viewing[3];
		var layerPosBase = imageSizeExpand.storage.viewing[4];
		var layerPos = imageSizeExpand.getElementPosition( imageSizeExpand.storage.viewing[1] );
		// 移動処理（横）
		var replaceL =  imageSizeExpand.getMoveValueLeft(scSize, originSize, layerPosBase, layerPos);
		if ( replaceL ) {
			imageSizeExpand.storage.viewing[1].style.left = replaceL + 'px';
		}
		// 移動処理（縦）
		var replaceT =  imageSizeExpand.getMoveValueTop(scSize, originSize, layerPosBase, layerPos);
		if ( replaceT ) {
			imageSizeExpand.storage.viewing[1].style.top = replaceT + 'px';
		}
		if ( replaceL || replaceT ) {
			window.setTimeout('imageSizeExpand.moveAnimation()', imageSizeExpand.conf.moveSpeed);
		} else {
			// 画像拡大
			imageSizeExpand.expand();
		}
	},
	//-----------------------------------------
	// 画像位置移動（dropdown）
	//-----------------------------------------
	dropdownAnimation : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var scSize = imageSizeExpand.storage.viewing[3];
		// 移動処理
		var val1 = ((scSize.width-originSize.width)/2) + (document.documentElement.scrollLeft||document.body.scrollLeft);
		var val2 = ((scSize.height-originSize.height)/2) + (document.documentElement.scrollTop||document.body.scrollTop);
		imageSizeExpand.setPosition( imageSizeExpand.storage.viewing[1], val2, val1 );
		// 拡大処理（幅）
		imageSizeExpand.storage.viewing[1].style.width = originSize.width + 'px';
		imageSizeExpand.storage.viewing[0].width = originSize.width;
		// layerと画像を表示
		imageSizeExpand.storage.viewing[1].style.visibility = 'visible';
		imageSizeExpand.storage.viewing[0].style.display = 'inline';
		// ドロップダウン開始
		imageSizeExpand.expand();
	},
	//-----------------------------------------
	// 画像位置移動（slide）
	//-----------------------------------------
	slideAnimation : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var scSize = imageSizeExpand.storage.viewing[3];
		var layerPosBase = imageSizeExpand.storage.viewing[4];
		// 拡大処理
		imageSizeExpand.setSize( imageSizeExpand.storage.viewing[0], originSize.width, originSize.height );
		imageSizeExpand.setSize( imageSizeExpand.storage.viewing[1], originSize.width, originSize.height );
		// 移動処理
		var val2 = ((scSize.height-originSize.height)/2) + (document.documentElement.scrollTop||document.body.scrollTop);
		var val1,goal = ((scSize.width-originSize.width)/2) + (document.documentElement.scrollLeft||document.body.scrollLeft);
		if ( layerPosBase.left > goal ) {
			val1 = originSize.width + layerPosBase.left;
		} else {
			val1 = 0 - originSize.width;
		}
		imageSizeExpand.setPosition( imageSizeExpand.storage.viewing[1], val2, val1 );
		// layerと画像を表示
		imageSizeExpand.storage.viewing[1].style.visibility = 'visible';
		imageSizeExpand.storage.viewing[0].style.display = 'inline';
		// スライド開始
		imageSizeExpand.moveAnimation();
	},
	//-----------------------------------------
	// 画像位置移動（fade）
	//-----------------------------------------
	fadeAnimation : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var scSize = imageSizeExpand.storage.viewing[3];
		// 移動処理
		var val1 = ((scSize.width-originSize.width)/2) + (document.documentElement.scrollLeft||document.body.scrollLeft);
		var val2 = ((scSize.height-originSize.height)/2) + (document.documentElement.scrollTop||document.body.scrollTop);
		imageSizeExpand.setPosition( imageSizeExpand.storage.viewing[1], val2, val1 );
		// 拡大処理
		imageSizeExpand.setSize( imageSizeExpand.storage.viewing[0], originSize.width, originSize.height );
		imageSizeExpand.setSize( imageSizeExpand.storage.viewing[1], originSize.width, originSize.height );
		// layerと画像を表示
		imageSizeExpand.storage.viewing[1].style.visibility = 'visible';
		imageSizeExpand.storage.viewing[0].style.display = 'inline';
		// fade開始
		imageSizeExpand.fade();
	},
	//-----------------------------------------
	// 画像のフェード
	//-----------------------------------------
	fade : function() {
		// 透明度設定
		var opacity = imageSizeExpand.getOpacity( imageSizeExpand.storage.viewing[0] );
		if ( opacity < 10 ) {
			// 透過処理
			imageSizeExpand.setOpacity( imageSizeExpand.storage.viewing[0], (opacity + 1.5) );
			window.setTimeout('imageSizeExpand.fade()', imageSizeExpand.conf.fadeSpeed);
		} else {
			// 実行中フラグリセット
			imageSizeExpand.storage.exec = false;
			// 表示フラグセット
			imageSizeExpand.storage.disp = true;
		}
	},
	//-----------------------------------------
	// 画像の拡大表示
	//-----------------------------------------
	expand : function() {
		// 必要情報を取得
		var originSize = imageSizeExpand.storage.viewing[2];
		var layerSize = imageSizeExpand.getElementSize( imageSizeExpand.storage.viewing[1] );
		// 拡大処理（幅）
		if ( originSize.width > layerSize.width ) {
			var replaceW = imageSizeExpand.getExpandValueWidth(originSize, layerSize);
			imageSizeExpand.storage.viewing[1].style.width = replaceW + 'px';
			imageSizeExpand.storage.viewing[0].width = replaceW;
		}
		// 拡大処理（高さ）
		if ( originSize.height > layerSize.height ) {
			var replaceH = imageSizeExpand.getExpandValueHeight(originSize, layerSize);
			imageSizeExpand.storage.viewing[1].style.height = replaceH + 'px';
			imageSizeExpand.storage.viewing[0].height = replaceH;
		}
		if ( (originSize.width > layerSize.width) || (originSize.height > layerSize.height) ) {
			window.setTimeout('imageSizeExpand.expand()', imageSizeExpand.conf.expandSpeed);
		} else {
			// 実行中フラグリセット
			imageSizeExpand.storage.exec = false;
			// 表示フラグセット
			imageSizeExpand.storage.disp = true;
		}
	},
	//-----------------------------------------
	// 画像の拡大値（幅）を取得する
	//-----------------------------------------
	getExpandValueWidth : function( originSize, layerSize ) {
		var add = (( originSize.width - layerSize.width ) * 0.1);
		if ( 7 > add ) { add += 7; }
		return (add + layerSize.width);
		
	},
	//-----------------------------------------
	// 画像の拡大値（高さ）を取得する
	//-----------------------------------------
	getExpandValueHeight : function( originSize, layerSize ) {
		var add = (( originSize.height - layerSize.height ) * 0.1);
		if ( 7 > add ) { add += 7; }
		return (add + layerSize.height);
	},
	//-----------------------------------------
	// 画像の移動値を取得する
	//-----------------------------------------
	getMoveValueLeft : function( scSize, originSize, layerPosBase, layerPos ) {
		var goal = ((scSize.width-originSize.width)/2) + (document.documentElement.scrollLeft||document.body.scrollLeft);
		if ( layerPosBase.left > goal ) {
			// 左移動
			if ( layerPos.left > goal ) {
				var add = (( layerPos.left - goal ) * 0.1);
				if ( 5 > add ) { add += 5; }
				return (layerPos.left - add);
			}
		} else {
			// 右移動
			if ( layerPos.left < goal ) {
				var add = (( layerPos.left - goal ) * 0.1);
				if ( -5 < add ) { add -= 5; }
				return (layerPos.left - add);
			}
		}
	},
	//-----------------------------------------
	// 画像の移動値（縦）を取得する
	//-----------------------------------------
	getMoveValueTop : function( scSize, originSize, layerPosBase, layerPos ) {
		var goal = ((scSize.height-originSize.height)/2) + (document.documentElement.scrollTop||document.body.scrollTop);
		if ( layerPosBase.top > goal ) {
			// 上移動
			if ( layerPos.top > goal ) {
				var add = (( layerPos.top - goal ) * 0.1);
				if ( 5 > add ) { add += 5; }
				return (layerPos.top - add);
			}
		} else {
			// 下移動
			if ( layerPos.top < goal ) {
				var add = (( layerPos.top - goal ) * 0.1);
				if ( -5 < add ) { add -= 5; }
				return (layerPos.top - add);
			}
		}
	},
	//-----------------------------------------
	// 画像のリサイズ値を返す
	//-----------------------------------------
	getResizeValue : function( size, scSize ) {
		var rate = size.width / size.height;
		var w = size.width;
		var h = size.height;
		if ( w > scSize.width && h > scSize.height ) {
			if ( w > h ) {
				w = (scSize.width - 100);
				h = w / rate;
			} else {
				h = (scSize.height - 100);
				w = h * rate;
			}
		} else if ( w > scSize.width ) {
			w = (scSize.width - 100);
			h = w / rate;
		} else {
			h = (scSize.height - 100);
			w = h * rate;
		}
		return ({ 'width' : w, 'height' : h });
	},
	//-----------------------------------------
	// ロールオーバー用layerを生成する
	//-----------------------------------------
	createRoLayer : function() {
		// div要素を生成
		var div = document.createElement('div');
		// 基本スタイル設定
		div.style.zIndex = '100';
		div.style.backgroundColor = 'transparent';
		div.style.cursor = 'pointer';
		imageSizeExpand.setOpacity( div, 0 );
		// サイズ設定
		div.style.width = '1px';
		div.style.height = '1px';
		// htmlに反映
		document.body.appendChild(div);
		// 返す
		return div;
	},
	//-----------------------------------------
	// layerを生成する
	//-----------------------------------------
	createLayer : function( image ) {
		// div要素を生成
		var div = document.createElement('div');
		// 基本スタイル設定
		div.style.zIndex = '200';
		div.style.cursor = 'pointer';
		div.style.margin = '0px';
		div.style.padding = '0px';
		// サイズ設定
		imageSizeExpand.setSize( div, 1, 1 );
		// 非表示
		div.style.visibility = 'hidden';
		// img要素を生成
		var img = document.createElement('img');
		// 基本スタイル設定
		img.style.margin = '0px';
		img.style.padding = '0px';
		img.style.cursor = 'pointer';
		img.style.display = 'none';
		// サイズ設定
		img.height = '';
		img.width = '';
		// src設定
		img.src = image.src;
		// divに追加
		div.appendChild(img);
		// htmlに反映
		document.body.appendChild(div);
		// 返す
		return div;
	},
	//-----------------------------------------
	// layerのスタイルをリセットする
	//-----------------------------------------
	resetLayer : function( layer, image ) {
		// 基本スタイル設定
		layer.style.zIndex = '200';
		layer.style.cursor = 'pointer';
		layer.style.margin = '0px';
		layer.style.padding = '0px';
		// サイズ設定
		imageSizeExpand.setSize( layer, 1, 1 );
		// 非表示
		layer.style.visibility = 'hidden';
		// 位置設定
		imageSizeExpand.setPosition( layer, 0, 0 );
		// 基本スタイル設定
		image.style.margin = '0px';
		image.style.padding = '0px';
		image.style.display = 'none';
		// サイズ設定
		image.height = '';
		image.width = '';
	},
	//-----------------------------------------
	// shimを生成する
	//-----------------------------------------
	createShim : function() {
		// iframe要素を生成
		var iframe = document.createElement('iframe');
		// 基本スタイル設定
		iframe.setAttribute('frameBorder', '0');
		iframe.setAttribute('scrolling', 'no');
		iframe.style.border = 'none';
		iframe.style.zIndex = '150';
		// サイズ設定
		imageSizeExpand.setSize( iframe, 1, 1 );
		// 非表示
		iframe.style.visibility = 'hidden';
		// htmlに反映
		document.body.appendChild(iframe);
		// 返す
		return iframe;
	},
	//-----------------------------------------
	// shimのスタイルをリセットする
	//-----------------------------------------
	resetShim : function( shim ) {
		// 基本スタイル設定
		shim.setAttribute('frameBorder', '0');
		shim.setAttribute('scrolling', 'no');
		shim.style.border = 'none';
		shim.style.zIndex = '150';
		// サイズ設定
		imageSizeExpand.setSize( shim, 1, 1 );
		// 位置設定
		imageSizeExpand.setPosition( shim, 0, 0 );
		// 非表示
		shim.style.visibility = 'hidden';
	},
	//-----------------------------------------
	// 要素の透明度を取得する
	//-----------------------------------------
	getOpacity : function( element ) {
		if ( element.alpha ) {
				return element.alpha / 10;
		} else if ( element.style ) {
			if ( element.style.opacity ) {
				return element.style.opacity * 10;
			}
		} 
		return 0;
	},
	//-----------------------------------------
	// 要素の透明度を設定する
	//-----------------------------------------
	setOpacity : function( element, val ) {
		element.style.opacity = val / 10;
		element.style.filter = 'alpha(opacity=' + val * 10 + ')';
		element.alpha = val * 10;
	},
	//-----------------------------------------
	// 要素の位置を設定する
	//-----------------------------------------
	setPosition : function( element, top, left ) {
		element.style.position = 'absolute';
		element.style.top = top + 'px';
		element.style.left = left + 'px';
	},
	//-----------------------------------------
	// 要素のサイズを設定する
	//-----------------------------------------
	setSize : function( element, width, height ) {
		if ( element.nodeName.match(/img/i) ) {
			element.width = width;
			element.height = height;
		} else {
			element.style.width = width + 'px';
			element.style.height = height + 'px';
		}
	},
	//-----------------------------------------
	// 対象要素のポジションを取得する
	//-----------------------------------------
	getElementPosition : function( element ) {
		var offsetTrail = (typeof element == 'string') ? document.getElementById(element): element;
		var x = 0;
		var y = 0;
		while (offsetTrail) {
			x += offsetTrail.offsetLeft;
			y += offsetTrail.offsetTop;
			offsetTrail = offsetTrail.offsetParent;
		}
		if ( navigator.userAgent.indexOf('Mac') != -1 && typeof doc.body.leftMargin != 'undefined' ) {
			x += document.body.leftMargin;
			y += document.body.topMargin;
		}
		return ({ 'left': x, 'top': y });
	},
	//-----------------------------------------
	// 対象要素のサイズを取得する
	//-----------------------------------------
	getElementSize : function( element ) {
		var w = element.offsetWidth;
		var h = element.offsetHeight;
		return ({ 'width': w, 'height': h });
	},
	//-----------------------------------------
	// 画像の本来のサイズを取得する
	//-----------------------------------------
	getOriginalImageSize : function( image ) {
		var run, mem, w, h, key = 'actual';
		// for Firefox, Safari, Google Chrome
		if ( 'naturalWidth' in image) {
			w = image.naturalWidth;
			h = image.naturalHeight;
			return ({ 'width' : w, 'height' : h });
		}
		// HTMLImageElement
		if ( 'src' in image ) {
			if ( image[key] && image[key].src === image.src ) {
				return image[key];
			}
			if ( document.uniqueID ) { 
				// for IE
				run = image.runtimeStyle;
				mem = { w:run.width, h:run.height }; // keep runtimeStyle
				run.width  = 'auto'; // override
				run.height = 'auto';
				w = image.width;
				h = image.height;
				run.width  = mem.w; // restore
				run.height = mem.h;
			} else {
				// for Opera and Other
				mem = { w:image.width, h:image.height }; // keep current style
				image.removeAttribute('width');
				image.removeAttribute('height');
				w = image.width;
				h = image.height;
				image.width  = mem.w; // restore
				image.height = mem.h;
			}
			return image[key] = { 'width' : w, 'height' : h, 'src' : image.src };
		}
		// HTMLCanvasElement
		return ({ 'width' : image.width, 'height' : image.height });
	},
	//-----------------------------------------
	// ブラウザの画面サイズを取得する
	//-----------------------------------------
	getScreenSize : function() {
		var w = 0;
		var h = 0;
		if ( window.innerWidth ) {
			w = window.innerWidth;
		} else if ( document.documentElement && document.documentElement.clientWidth != 0 ) {
			w = document.documentElement.clientWidth;
		} else if ( document.body ) {
			w = document.body.clientWidth;
		}
		if ( window.innerHeight ) {
			h = window.innerHeight;
		} else if ( document.documentElement && document.documentElement.clientHeight != 0 ) {
			h = document.documentElement.clientHeight;
		} else if ( document.body ) {
			h = document.body.clientHeight;
		}
		return ({ 'width': w, 'height': h });
	},
	//-----------------------------------------
	// ページのサイズを取得する
	//-----------------------------------------
	getPageSize : function() {
		var xScroll, yScroll;
		if ( window.innerHeight && window.scrollMaxY ) {
			xScroll = window.innerWidth + window.scrollMaxX;
			yScroll = window.innerHeight + window.scrollMaxY;
		} else if ( document.body.scrollHeight > document.body.offsetHeight ){
			// all but Explorer Mac
			xScroll = document.body.scrollWidth;
			yScroll = document.body.scrollHeight;
		} else {
			// Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
			xScroll = document.body.offsetWidth;
			yScroll = document.body.offsetHeight;
		}
		var windowWidth, windowHeight;
		if ( self.innerHeight ) {
			// all except Explorer
			if(document.documentElement.clientWidth){
				windowWidth = document.documentElement.clientWidth; 
			} else {
				windowWidth = self.innerWidth;
			}
			windowHeight = self.innerHeight;
		} else if (document.documentElement && document.documentElement.clientHeight) {
			// Explorer 6 Strict Mode
			windowWidth = document.documentElement.clientWidth;
			windowHeight = document.documentElement.clientHeight;
		} else if (document.body) {
			// other Explorers
			windowWidth = document.body.clientWidth;
			windowHeight = document.body.clientHeight;
		}
		// for small pages with total height less then height of the viewport
		if ( yScroll < windowHeight ) {
			pageHeight = windowHeight;
		} else { 
			pageHeight = yScroll;
		}
		// for small pages with total width less then width of the viewport
		if ( xScroll < windowWidth ) {
			pageWidth = windowWidth;
		} else {
			pageWidth = xScroll;
		}
		//return [pageWidth,pageHeight];
		return ({ 'width' : pageWidth, 'height' : pageHeight });
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function( tag, cls ) {
		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag.toUpperCase());
		var len = targetElements.length;
		for ( var i = 0; i < len; i++ ) {
			if ( targetElements[i].className.match(cls) ) {
				elements.push(targetElements[i]);
			}
		}
		return elements;
	},
	//-----------------------------------------
	// IE判定
	//-----------------------------------------
	isIE : function() {
		return IE='\v'=='v';
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
imageSizeExpand.addEvent( window, 'load', imageSizeExpand.init );